(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    160958,       3826]
NotebookOptionsPosition[    158967,       3755]
NotebookOutlinePosition[    159324,       3771]
CellTagsIndexPosition[    159281,       3768]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "This", " ", "file", " ", "includes", " ", "a", " ", "solution", " ", 
      "for", " ", "a", " ", "geometrical", " ", "modeling", " ", "of", " ", 
      "3", "D", " ", "eye"}], "-", 
     RowBox[{"tracking", " ", "calibration"}]}], ",", " ", 
    RowBox[{
     RowBox[{
     "we", " ", "will", " ", "use", " ", "this", " ", "file", " ", "for", " ",
       "prototyping", " ", "our", " ", 
      RowBox[{"solution", ".", " ", "\[IndentingNewLine]", "These"}], " ", 
      "are", " ", "some", " ", "assumptions", " ", "and", " ", "notations", 
      " ", "used", " ", "for", " ", "solving", " ", "the", " ", "problem"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{
     "We", " ", "assumed", " ", "that", " ", "four", " ", "LEDs", " ", "were",
       " ", "used", " ", "and", " ", "the", " ", "gaze", " ", "locations", 
      " ", "for", " ", "both", " ", "eyes", " ", "in", " ", "a", " ", 
      "calbrated", " ", "projection", " ", "plane", " ", "are", " ", "given", 
      " ", "for", " ", "each", " ", 
      RowBox[{"LED", ".", " ", "SO"}], " ", "we", " ", "will", " ", "have", 
      " ", "8", " ", "points", " ", "on", " ", "projection", " ", "screen", 
      " ", "for", " ", "two", " ", "eyes", " ", "and", " ", "four", " ", 
      RowBox[{"LEDs", ".", "\[IndentingNewLine]", "We"}], " ", "also", " ", 
      "assume", " ", "that", " ", "LEDs", " ", "are", " ", "arranged", " ", 
      "in", " ", "this", " ", 
      RowBox[{"order", " ", ":", " ", 
       RowBox[{"1", ":", " ", 
        RowBox[{"Top", "-", " ", "right"}]}]}]}]}], " ", ",", " ", 
    RowBox[{"2", ":", " ", 
     RowBox[{"bottom", " ", "-", "right"}]}], " ", ",", 
    RowBox[{"3", ":", 
     RowBox[{
      RowBox[{"bottom", "-", 
       RowBox[{"left", "  ", "and", " ", "\[IndentingNewLine]", "4"}]}], ":", 
      " ", 
      RowBox[{"top", "-", 
       RowBox[{
        RowBox[{"left", ".", " ", "\[IndentingNewLine]", "We"}], " ", 
        "assume", " ", "that", " ", "the", " ", "vector", " ", "connecting", 
        " ", "1", " ", "and", " ", "2", " ", "is", " ", "vertical", " ", 
        "and", " ", "the", " ", "vector", " ", "conncecting", " ", "3", " ", 
        "and", " ", "4", " ", "is", " ", "also", " ", 
        RowBox[{"vertical", ".", " ", "We"}], " ", "assume", " ", "that", " ",
         "projection", " ", "screen", " ", "is", " ", "also", " ", 
        RowBox[{"vertical", ".", "Meanwhile"}], " ", "we", " ", "assume", " ",
         "that", " ", "LED", " ", "planes", " ", "is", " ", "not", " ", 
        "parallel", " ", "to", " ", "2", "D", " ", "calibration", " ", 
        RowBox[{"screen", "."}]}]}]}]}]}], "  ", "\[IndentingNewLine]", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notations", ":", " ", "\[IndentingNewLine]", 
     StyleBox[
      RowBox[{"R", 
       StyleBox["i",
        FontSlant->"Italic"]}]]}], ";", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       StyleBox[
        RowBox[{"x", 
         StyleBox["i",
          FontSlant->"Italic"]}]], 
       StyleBox[",",
        FontSlant->"Italic"], 
       StyleBox[
        RowBox[{"y", 
         StyleBox["i",
          FontSlant->"Italic"]}]], 
       StyleBox[",",
        FontSlant->"Italic"], 
       StyleBox[
        RowBox[{"z", 
         StyleBox["i",
          FontSlant->"Italic"]}]]}], ")"}], " ", "location", " ", "of", " ", 
     "LED", " ", "number", " ", 
     StyleBox["i",
      FontSlant->"Italic"], " ", "in", " ", "the", " ", "space", 
     "\[IndentingNewLine]", "Er"}], ";", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"erx", ",", "ery", ",", "erz"}], ")"}], " ", "location", " ", 
     "of", " ", "right", " ", "eye", " ", "in", " ", "the", " ", "space", 
     "\[IndentingNewLine]", "El"}], ";", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"elx", ",", "ely", ",", "elz"}], ")"}], " ", "location", " ", 
     "of", " ", "left", " ", "eye", " ", "in", " ", "the", " ", "space", 
     "\[IndentingNewLine]", "Ec"}], ";", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"ecx", ",", "ecy", ",", "ecz"}], ")"}], " ", "location", " ", 
     "of", " ", "midpoint", " ", "of", " ", "two", " ", "eyes", 
     "\[IndentingNewLine]", 
     StyleBox[
      RowBox[{"Pr", 
       StyleBox["i",
        FontSlant->"Italic"]}]]}], ";", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       StyleBox[
        RowBox[{"rx", 
         StyleBox["i",
          FontSlant->"Italic"]}]], 
       StyleBox[",",
        FontSlant->"Italic"], 
       StyleBox[
        RowBox[{"ry", 
         StyleBox["i",
          FontSlant->"Italic"]}]], 
       StyleBox[",",
        FontSlant->"Italic"], 
       StyleBox["0",
        FontSlant->"Italic"]}], ")"}], " ", "location", " ", "of", " ", 
     "prjection", " ", "of", " ", "right", " ", "eye", " ", "gaze", " ", "at",
      " ", "LED", " ", 
     StyleBox["i",
      FontSlant->"Italic"], " ", "onto", " ", "projection", " ", "screen", 
     " ", "\[IndentingNewLine]", 
     StyleBox[
      RowBox[{"Pl", 
       StyleBox["i",
        FontSlant->"Italic"]}]]}], 
    StyleBox[";",
     FontSlant->"Italic"], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       StyleBox[
        RowBox[{"lx", 
         StyleBox["i",
          FontSlant->"Italic"]}]], 
       StyleBox[",",
        FontSlant->"Italic"], 
       StyleBox[
        RowBox[{"ly", 
         StyleBox["i",
          FontSlant->"Italic"]}]], 
       StyleBox[",",
        FontSlant->"Italic"], 
       StyleBox["0",
        FontSlant->"Italic"]}], ")"}], " ", "location", " ", "of", " ", 
     "projection", " ", "of", " ", "left", " ", "eye", " ", "gaze", " ", "at",
      " ", "LED", " ", 
     StyleBox["i",
      FontSlant->"Italic"], 
     StyleBox[" ",
      FontSlant->"Italic"], "onto", " ", "projection", " ", "screen"}]}], 
   "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
    "We", " ", "arrange", " ", "our", " ", "coordinate", " ", "system", " ", 
     "in", " ", "this", " ", 
     RowBox[{"way", ":", " ", 
      RowBox[{"x", " ", "along", " ", "vertical", " ", "direction", " ", 
       RowBox[{"(", 
        RowBox[{"top", "-", "down"}], ")"}], " ", "along", " ", "left", " ", 
       "edge", " ", "of", " ", "the", " ", "calbration", " ", "screen"}]}]}], 
    ",", " ", 
    RowBox[{
    "y", " ", "along", " ", "top", " ", "horizontal", " ", "edge", " ", "of", 
     " ", "the", " ", "calbration", " ", "screen", 
     RowBox[{"(", 
      RowBox[{"left", " ", "to", " ", "right"}], ")"}], " ", "and", " ", "z", 
     " ", "perpendicular", " ", "to", " ", "calibration", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"back", " ", "to", " ", "front"}], ")"}], ".", " ", 
      "\[IndentingNewLine]", "The"}], " ", "distance", " ", "between", " ", 
     "LED1", " ", "and", " ", "LED2", " ", "equals", " ", "to", " ", 
     "distance", " ", "between", " ", "LED3", " ", "and", " ", "LED4", " ", 
     "and", " ", "equal", " ", "to", " ", "a"}]}], " ", "\[IndentingNewLine]",
    "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"For", " ", "right", " ", "eye", " ", "and", " ", "R1"}], " ", 
     ";", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Er", "-", "R1"}], ")"}], "x", 
       RowBox[{"(", 
        RowBox[{"Er", "-", "Pr1"}], ")"}]}], "=", "0"}]}], " ", ",", 
    RowBox[{
     RowBox[{"for", " ", "right", " ", "eye", " ", "and", " ", "R2"}], " ", 
     ";", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Er", "-", "R2"}], ")"}], "x", 
       RowBox[{"(", 
        RowBox[{"Er", "-", "Pr2"}], ")"}]}], "=", 
      RowBox[{
      "0", "\[IndentingNewLine]", " ", "solving", " ", "these", " ", "two", 
       " ", "equations", " ", "in", " ", "one", " ", "system", " ", "will", 
       " ", "result", " ", "to"}]}]}]}], "\[IndentingNewLine]", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"s1", "=", 
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"ecx", "-", "x1"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"ecx", "-", "rx1"}], ")"}]}], "\[Equal]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"k", "+", "d", "-", "y1"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"k", "+", "d", "-", "ry1"}], ")"}]}], "==", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"ecz", "-", "z1"}], ")"}], "/", 
        RowBox[{"(", "ecz", ")"}]}], "\[Equal]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"k", "-", "d", "-", "y1"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"k", "-", "d", "-", "ly1"}], ")"}]}], "\[Equal]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"ecx", "-", "x1", "-", "a"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"ecx", "-", "rx2"}], ")"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x1", ",", "y1", ",", "z1", ",", "d"}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.493687251634924*^9, 3.493687288552408*^9}, {
   3.493687325722644*^9, 3.493687471422793*^9}, {3.493687542781525*^9, 
   3.493687676228912*^9}, {3.493687779264503*^9, 3.493687853893961*^9}, 
   3.49372636146351*^9, {3.493726410179535*^9, 3.493726481768482*^9}, {
   3.493726540010714*^9, 3.493726808972816*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"z1", "\[Rule]", 
     FractionBox[
      RowBox[{"ecz", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "a"}], "-", "rx1", "+", "rx2"}], ")"}]}], 
      RowBox[{
       RowBox[{"-", "rx1"}], "+", "rx2"}]]}], ",", 
    RowBox[{"y1", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"ly1", "+", 
        FractionBox[
         RowBox[{"2", " ", "a", " ", "k"}], 
         RowBox[{"ecx", "-", "rx2"}]], "-", 
        FractionBox[
         RowBox[{"a", " ", "ly1"}], 
         RowBox[{"ecx", "-", "rx2"}]], "-", 
        FractionBox[
         RowBox[{"2", " ", "k", " ", "rx2"}], 
         RowBox[{"ecx", "-", "rx2"}]], "+", 
        FractionBox[
         RowBox[{"ly1", " ", "rx2"}], 
         RowBox[{"ecx", "-", "rx2"}]], "+", 
        FractionBox[
         RowBox[{"2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"a", " ", "ecx"}], "-", 
            RowBox[{"a", " ", "rx1"}], "+", 
            RowBox[{"ecx", " ", "rx1"}], "-", 
            RowBox[{"ecx", " ", "rx2"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"ecx", "-", "rx2"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"rx1", "-", "rx2"}], ")"}]}]], "-", 
        FractionBox[
         RowBox[{"ly1", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"a", " ", "ecx"}], "-", 
            RowBox[{"a", " ", "rx1"}], "+", 
            RowBox[{"ecx", " ", "rx1"}], "-", 
            RowBox[{"ecx", " ", "rx2"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"ecx", "-", "rx2"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"rx1", "-", "rx2"}], ")"}]}]], "+", "ry1", "-", 
        FractionBox[
         RowBox[{"a", " ", "ry1"}], 
         RowBox[{"ecx", "-", "rx2"}]], "+", 
        FractionBox[
         RowBox[{"rx2", " ", "ry1"}], 
         RowBox[{"ecx", "-", "rx2"}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"a", " ", "ecx"}], "-", 
            RowBox[{"a", " ", "rx1"}], "+", 
            RowBox[{"ecx", " ", "rx1"}], "-", 
            RowBox[{"ecx", " ", "rx2"}]}], ")"}], " ", "ry1"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"ecx", "-", "rx2"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"rx1", "-", "rx2"}], ")"}]}]]}], ")"}]}]}], ",", 
    RowBox[{"d", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "a"}], " ", "ly1"}], "+", 
       RowBox[{"a", " ", "ry1"}]}], 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"a", "+", "rx1", "-", "rx2"}], ")"}]}]]}], ",", 
    RowBox[{"x1", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"a", " ", "ecx"}], "-", 
       RowBox[{"a", " ", "rx1"}], "+", 
       RowBox[{"ecx", " ", "rx1"}], "-", 
       RowBox[{"ecx", " ", "rx2"}]}], 
      RowBox[{"rx1", "-", "rx2"}]]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.493687660219304*^9, 3.493687679804937*^9}, {
  3.493687786845037*^9, 3.493687855811835*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"x1", "/.", "s1"}], "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.493687688349548*^9, 3.493687771461533*^9}, {
  3.493687900767961*^9, 3.493687901832874*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"ecx", "+", 
   FractionBox[
    RowBox[{"a", " ", 
     RowBox[{"(", 
      RowBox[{"ecx", "-", "rx1"}], ")"}]}], 
    RowBox[{"rx1", "-", "rx2"}]]}], "}"}]], "Output",
 CellChangeTimes->{{3.493687730064456*^9, 3.493687772905423*^9}, 
   3.493687902701206*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"y1", "/.", "s1"}], "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.493687910951816*^9, 3.493687929325597*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"-", 
   FractionBox[
    RowBox[{
     RowBox[{"2", " ", "k", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "rx1"}], "+", "rx2"}], ")"}]}], "+", 
     RowBox[{"a", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", "k"}], "+", "ly1", "+", "ry1"}], ")"}]}]}], 
    
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"rx1", "-", "rx2"}], ")"}]}]]}], "}"}]], "Output",
 CellChangeTimes->{3.493687930686304*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"z1", "/.", "s1"}], "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.49368793481257*^9, 3.493687968938874*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"ecz", "+", 
   FractionBox[
    RowBox[{"a", " ", "ecz"}], 
    RowBox[{"rx1", "-", "rx2"}]]}], "}"}]], "Output",
 CellChangeTimes->{{3.493687954824038*^9, 3.493687970330644*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", "/.", "s1"}], "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.49368801395336*^9, 3.493688029602224*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"a", "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "ly1"}], " ", "+", " ", "ry1"}], ")"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"2", "*", 
     RowBox[{"(", 
      RowBox[{"a", " ", "+", " ", "rx1", " ", "-", " ", "rx2"}], ")"}]}], 
    ")"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.493702721381403*^9, 3.493702721601467*^9}},
 FormatType->"InputForm"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"s2", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"ecx", " ", "-", " ", "x3"}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"ecx", " ", "-", " ", "rx3"}], ")"}]}], "\[Equal]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"k", "+", "d", "  ", "-", " ", "y3"}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"k", "+", "d", " ", "-", "ry3"}], ")"}]}], "\[Equal]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"ecz", " ", "-", " ", "z3"}], ")"}], "/", "ecz"}], "\[Equal]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"k", "-", "d", " ", "-", " ", "y3"}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"k", " ", "-", " ", "d", " ", "-", " ", "ly3"}], ")"}]}], 
      "\[Equal]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"ecx", " ", "-", " ", "x3", " ", "+", " ", "a"}], ")"}], "/", 
       
       RowBox[{"(", 
        RowBox[{"ecx", " ", "-", " ", "rx4"}], ")"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x3", ",", "y3", ",", "z3", ",", "d"}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.49369784547306*^9, 3.493698109992532*^9}, {
  3.493698244137949*^9, 3.493698252223931*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"z3", "\[Rule]", 
     FractionBox[
      RowBox[{"ecz", " ", 
       RowBox[{"(", 
        RowBox[{"a", "-", "rx3", "+", "rx4"}], ")"}]}], 
      RowBox[{
       RowBox[{"-", "rx3"}], "+", "rx4"}]]}], ",", 
    RowBox[{"y3", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"ly3", "-", 
        FractionBox[
         RowBox[{"2", " ", "a", " ", "k"}], 
         RowBox[{"ecx", "-", "rx4"}]], "+", 
        FractionBox[
         RowBox[{"a", " ", "ly3"}], 
         RowBox[{"ecx", "-", "rx4"}]], "-", 
        FractionBox[
         RowBox[{"2", " ", "k", " ", "rx4"}], 
         RowBox[{"ecx", "-", "rx4"}]], "+", 
        FractionBox[
         RowBox[{"ly3", " ", "rx4"}], 
         RowBox[{"ecx", "-", "rx4"}]], "+", 
        FractionBox[
         RowBox[{"2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "a"}], " ", "ecx"}], "+", 
            RowBox[{"a", " ", "rx3"}], "+", 
            RowBox[{"ecx", " ", "rx3"}], "-", 
            RowBox[{"ecx", " ", "rx4"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"ecx", "-", "rx4"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"rx3", "-", "rx4"}], ")"}]}]], "-", 
        FractionBox[
         RowBox[{"ly3", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "a"}], " ", "ecx"}], "+", 
            RowBox[{"a", " ", "rx3"}], "+", 
            RowBox[{"ecx", " ", "rx3"}], "-", 
            RowBox[{"ecx", " ", "rx4"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"ecx", "-", "rx4"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"rx3", "-", "rx4"}], ")"}]}]], "+", "ry3", "+", 
        FractionBox[
         RowBox[{"a", " ", "ry3"}], 
         RowBox[{"ecx", "-", "rx4"}]], "+", 
        FractionBox[
         RowBox[{"rx4", " ", "ry3"}], 
         RowBox[{"ecx", "-", "rx4"}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "a"}], " ", "ecx"}], "+", 
            RowBox[{"a", " ", "rx3"}], "+", 
            RowBox[{"ecx", " ", "rx3"}], "-", 
            RowBox[{"ecx", " ", "rx4"}]}], ")"}], " ", "ry3"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"ecx", "-", "rx4"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"rx3", "-", "rx4"}], ")"}]}]]}], ")"}]}]}], ",", 
    RowBox[{"d", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "a"}], " ", "ly3"}], "+", 
       RowBox[{"a", " ", "ry3"}]}], 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"a", "-", "rx3", "+", "rx4"}], ")"}]}]]}], ",", 
    RowBox[{"x3", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "a"}], " ", "ecx"}], "+", 
       RowBox[{"a", " ", "rx3"}], "+", 
       RowBox[{"ecx", " ", "rx3"}], "-", 
       RowBox[{"ecx", " ", "rx4"}]}], 
      RowBox[{"rx3", "-", "rx4"}]]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.493698111626903*^9, {3.493698254662396*^9, 3.493698264672784*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"x3", "/.", "s2"}], "//", "FullSimplify"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.493698126210823*^9, 3.493698148035771*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"ecx", "+", 
   FractionBox[
    RowBox[{"a", " ", 
     RowBox[{"(", 
      RowBox[{"ecx", "-", "rx3"}], ")"}]}], 
    RowBox[{
     RowBox[{"-", "rx3"}], "+", "rx4"}]]}], "}"}]], "Output",
 CellChangeTimes->{3.49369826801122*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.493698256889235*^9, 3.493698273888663*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.493698278935809*^9, 3.493698279145882*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"y3", "/.", "s2"}], "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.493698154492289*^9, 3.493698168363157*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  FractionBox[
   RowBox[{
    RowBox[{"2", " ", "k", " ", 
     RowBox[{"(", 
      RowBox[{"rx3", "-", "rx4"}], ")"}]}], "+", 
    RowBox[{"a", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "k"}], "+", "ly3", "+", "ry3"}], ")"}]}]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{"rx3", "-", "rx4"}], ")"}]}]], "}"}]], "Output",
 CellChangeTimes->{3.49369817024251*^9, 3.493698284858381*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"z3", "/.", "s2"}], "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.493698175282403*^9, 3.493698188534431*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"ecz", "+", 
   FractionBox[
    RowBox[{"a", " ", "ecz"}], 
    RowBox[{
     RowBox[{"-", "rx3"}], "+", "rx4"}]]}], "}"}]], "Output",
 CellChangeTimes->{3.493698189639691*^9, 3.493698291777617*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"d", "/.", "s2"}], "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.493698195114913*^9, 3.493698204900019*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"a", "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "ly3"}], " ", "+", " ", "ry3"}], ")"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"2", "*", 
     RowBox[{"(", 
      RowBox[{"a", " ", "-", " ", "rx3", " ", "+", " ", "rx4"}], ")"}]}], 
    ")"}]}], "}"}]], "Output",
 CellChangeTimes->{3.493699193235292*^9},
 FormatType->"InputForm"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.493698536256442*^9, 3.493698540918299*^9}, {
  3.493699187967752*^9, 3.493699190176071*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.493698389447779*^9, 3.493698406587061*^9}, {
  3.493698453961322*^9, 3.493698503703337*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"secx", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ecx", "+", 
       FractionBox[
        RowBox[{"a", " ", 
         RowBox[{"(", 
          RowBox[{"ecx", "-", "rx3"}], ")"}]}], 
        RowBox[{
         RowBox[{"-", "rx3"}], "+", "rx4"}]]}], "==", 
      RowBox[{"ecx", "+", 
       FractionBox[
        RowBox[{"a", " ", 
         RowBox[{"(", 
          RowBox[{"ecx", "-", "rx1"}], ")"}]}], 
        RowBox[{"rx1", "-", "rx2"}]], "+", "a"}]}], "}"}], ",", "ecx"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.493698546645875*^9, 3.493698548406968*^9}, {
  3.493698612772894*^9, 3.493698618351304*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"ecx", "\[Rule]", 
    FractionBox[
     RowBox[{"a", "-", 
      FractionBox[
       RowBox[{"a", " ", "rx1"}], 
       RowBox[{"rx1", "-", "rx2"}]], "+", 
      FractionBox[
       RowBox[{"a", " ", "rx3"}], 
       RowBox[{
        RowBox[{"-", "rx3"}], "+", "rx4"}]]}], 
     RowBox[{
      RowBox[{"-", 
       FractionBox["a", 
        RowBox[{"rx1", "-", "rx2"}]]}], "+", 
      FractionBox["a", 
       RowBox[{
        RowBox[{"-", "rx3"}], "+", "rx4"}]]}]]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.493698551376814*^9, 3.493698620502319*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ecx", "/.", "secx"}], "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.493698625624742*^9, 3.493698655858329*^9}}],

Cell["{(rx1*rx3 - rx2*rx4)/(rx1 - rx2 + rx3 - rx4)}", "Output",
 CellChangeTimes->{3.493698656717794*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.49369851397548*^9, 3.493698516512309*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{"now", " ", 
     RowBox[{"let", "'"}], "s", " ", "solve", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z3", " ", "-", " ", "z1"}], ")"}], "^", "2"}]}], " ", "+", 
    " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"y3", " ", "-", " ", "y1"}], ")"}], "^", "2"}]}], " ", "==", 
   " ", 
   RowBox[{"b", "^", "2"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.493698521609626*^9, 3.493698531903932*^9}, {
   3.493699438845847*^9, 3.493699486370887*^9}, 3.493699524492098*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"secz", " ", "=", " ", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"z3", " ", "-", " ", "z1"}], ")"}], "^", "2"}], " ", "+", 
        " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"y3", " ", "-", " ", "y1"}], ")"}], "^", "2"}]}], " ", "==",
        " ", 
       RowBox[{"b", "^", "2"}]}], " ", ",", " ", 
      RowBox[{
       RowBox[{"ecz", "+", 
        FractionBox[
         RowBox[{"a", " ", "ecz"}], 
         RowBox[{
          RowBox[{"-", "rx3"}], "+", "rx4"}]]}], "\[Equal]", "z3"}], ",", 
      RowBox[{
       RowBox[{"ecz", "+", 
        FractionBox[
         RowBox[{"a", " ", "ecz"}], 
         RowBox[{"rx1", "-", "rx2"}]]}], "==", "z1"}], ",", 
      RowBox[{"y1", "==", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"2", " ", "k", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "rx1"}], "+", "rx2"}], ")"}]}], "+", 
          RowBox[{"a", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "2"}], " ", "k"}], "+", "ly1", "+", "ry1"}], 
            ")"}]}]}], 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{"rx1", "-", "rx2"}], ")"}]}]]}]}], ",", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"2", " ", "k", " ", 
          RowBox[{"(", 
           RowBox[{"rx3", "-", "rx4"}], ")"}]}], "+", 
         RowBox[{"a", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "2"}], " ", "k"}], "+", "ly3", "+", "ry3"}], 
           ")"}]}]}], 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{"rx3", "-", "rx4"}], ")"}]}]], "\[Equal]", "y3"}]}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"ecz", ",", "z1", ",", "z3", ",", "y1", ",", "y3"}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.493699495250845*^9, 3.493699655314085*^9}, {
  3.49369968752594*^9, 3.493699707823396*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"z1", "\[Rule]", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Sqrt]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "4"}], " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", 
              SuperscriptBox["rx1", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
              SuperscriptBox["rx1", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["ly3", "2"], " ", 
              SuperscriptBox["rx1", "2"]}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", "rx1", " ", "rx2"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ",
               "rx2"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["ly3", "2"], " ", "rx1", " ", "rx2"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", 
              SuperscriptBox["rx2", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
              SuperscriptBox["rx2", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["ly3", "2"], " ", 
              SuperscriptBox["rx2", "2"]}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", "rx1", " ", "rx3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ",
               "rx3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ",
               "rx3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
              " ", "rx3"}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", "rx2", " ", "rx3"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ",
               "rx3"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ",
               "rx3"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
              " ", "rx3"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", 
              SuperscriptBox["rx3", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
              SuperscriptBox["rx3", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["ly1", "2"], " ", 
              SuperscriptBox["rx3", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["rx1", "2"], " ", 
              SuperscriptBox["rx3", "2"]}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
              SuperscriptBox["rx3", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["rx2", "2"], " ", 
              SuperscriptBox["rx3", "2"]}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", "rx1", " ", "rx4"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ",
               "rx4"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ",
               "rx4"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
              " ", "rx4"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", "rx2", " ", "rx4"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ",
               "rx4"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ",
               "rx4"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
              " ", "rx4"}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", "rx3", " ", "rx4"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx3", " ",
               "rx4"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["ly1", "2"], " ", "rx3", " ", "rx4"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["rx1", "2"], " ", "rx3", " ", "rx4"}], "+", 
             RowBox[{"16", " ", 
              SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", "rx3", 
              " ", "rx4"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["rx2", "2"], " ", "rx3", " ", "rx4"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", 
              SuperscriptBox["rx4", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
              SuperscriptBox["rx4", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["ly1", "2"], " ", 
              SuperscriptBox["rx4", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["rx1", "2"], " ", 
              SuperscriptBox["rx4", "2"]}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
              SuperscriptBox["rx4", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["rx2", "2"], " ", 
              SuperscriptBox["rx4", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ",
               "ry1"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx3", 
              " ", "ry1"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ",
               "ry1"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx3", 
              " ", "ry1"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", 
              SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", 
              SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ",
               "ry1"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx4", 
              " ", "ry1"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ",
               "ry1"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx4", 
              " ", "ry1"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx3", " ", "rx4", " ",
               "ry1"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "rx3", " ", "rx4", 
              " ", "ry1"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", 
              SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", 
              SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["rx3", "2"], " ", 
              SuperscriptBox["ry1", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "rx3", " ", "rx4", " ", 
              SuperscriptBox["ry1", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["rx4", "2"], " ", 
              SuperscriptBox["ry1", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", 
              SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", 
              SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx2", " ",
               "ry3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx2", 
              " ", "ry3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", 
              SuperscriptBox["rx2", "2"], " ", "ry3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", 
              SuperscriptBox["rx2", "2"], " ", "ry3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ",
               "ry3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx3", 
              " ", "ry3"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ",
               "ry3"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx3", 
              " ", "ry3"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ",
               "ry3"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx4", 
              " ", "ry3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ",
               "ry3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx4", 
              " ", "ry3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "rx1", " ", "rx3", " ", "ry1", 
              " ", "ry3"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "rx2", " ", "rx3", " ", "ry1", 
              " ", "ry3"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "rx1", " ", "rx4", " ", "ry1", 
              " ", "ry3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "rx2", " ", "rx4", " ", "ry1", 
              " ", "ry3"}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["rx1", "2"], " ", 
              SuperscriptBox["ry3", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "rx1", " ", "rx2", " ", 
              SuperscriptBox["ry3", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["rx2", "2"], " ", 
              SuperscriptBox["ry3", "2"]}]}], ")"}]}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"a", " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"4", " ", 
              SuperscriptBox["rx1", "2"]}], "-", 
             RowBox[{"8", " ", "rx1", " ", "rx2"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["rx2", "2"]}], "+", 
             RowBox[{"8", " ", "rx1", " ", "rx3"}], "-", 
             RowBox[{"8", " ", "rx2", " ", "rx3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["rx3", "2"]}], "-", 
             RowBox[{"8", " ", "rx1", " ", "rx4"}], "+", 
             RowBox[{"8", " ", "rx2", " ", "rx4"}], "-", 
             RowBox[{"8", " ", "rx3", " ", "rx4"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["rx4", "2"]}]}]]}], ")"}]}]}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "4"}], " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx2"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx3"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx4"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx4"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx3", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", "rx3", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx3", 
             " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx3", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx4", 
             " ", "ry1"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx3", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx3", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx3", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx3", " ", "rx4", " ", 
             SuperscriptBox["ry1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx4", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx2", " ", 
             "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx2", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx4", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx4", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["ry3", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["ry3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["ry3", "2"]}]}], ")"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"rx1", "-", "rx2"}], ")"}], " ", 
          SqrtBox[
           RowBox[{
            RowBox[{"4", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx2"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"8", " ", "rx1", " ", "rx3"}], "-", 
            RowBox[{"8", " ", "rx2", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx4"}], "+", 
            RowBox[{"8", " ", "rx2", " ", "rx4"}], "-", 
            RowBox[{"8", " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx4", "2"]}]}]]}], ")"}]}]}]}], ",", 
     RowBox[{"y1", "\[Rule]", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "a", " ", "k"}], "-", 
        RowBox[{"a", " ", "ly1"}], "+", 
        RowBox[{"2", " ", "k", " ", "rx1"}], "-", 
        RowBox[{"2", " ", "k", " ", "rx2"}], "-", 
        RowBox[{"a", " ", "ry1"}]}], 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"rx1", "-", "rx2"}], ")"}]}]]}], ",", 
     RowBox[{"y3", "\[Rule]", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", "a", " ", "k"}], "+", 
        RowBox[{"a", " ", "ly3"}], "+", 
        RowBox[{"2", " ", "k", " ", "rx3"}], "-", 
        RowBox[{"2", " ", "k", " ", "rx4"}], "+", 
        RowBox[{"a", " ", "ry3"}]}], 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"rx3", "-", "rx4"}], ")"}]}]]}], ",", 
     RowBox[{"z3", "\[Rule]", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Sqrt]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "4"}], " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", 
              SuperscriptBox["rx1", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
              SuperscriptBox["rx1", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["ly3", "2"], " ", 
              SuperscriptBox["rx1", "2"]}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", "rx1", " ", "rx2"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ",
               "rx2"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["ly3", "2"], " ", "rx1", " ", "rx2"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", 
              SuperscriptBox["rx2", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
              SuperscriptBox["rx2", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["ly3", "2"], " ", 
              SuperscriptBox["rx2", "2"]}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", "rx1", " ", "rx3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ",
               "rx3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ",
               "rx3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
              " ", "rx3"}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", "rx2", " ", "rx3"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ",
               "rx3"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ",
               "rx3"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
              " ", "rx3"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", 
              SuperscriptBox["rx3", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
              SuperscriptBox["rx3", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["ly1", "2"], " ", 
              SuperscriptBox["rx3", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["rx1", "2"], " ", 
              SuperscriptBox["rx3", "2"]}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
              SuperscriptBox["rx3", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["rx2", "2"], " ", 
              SuperscriptBox["rx3", "2"]}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", "rx1", " ", "rx4"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ",
               "rx4"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ",
               "rx4"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
              " ", "rx4"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", "rx2", " ", "rx4"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ",
               "rx4"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ",
               "rx4"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
              " ", "rx4"}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", "rx3", " ", "rx4"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx3", " ",
               "rx4"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["ly1", "2"], " ", "rx3", " ", "rx4"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["rx1", "2"], " ", "rx3", " ", "rx4"}], "+", 
             RowBox[{"16", " ", 
              SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", "rx3", 
              " ", "rx4"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["rx2", "2"], " ", "rx3", " ", "rx4"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["k", "2"], " ", 
              SuperscriptBox["rx4", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
              SuperscriptBox["rx4", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["ly1", "2"], " ", 
              SuperscriptBox["rx4", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["rx1", "2"], " ", 
              SuperscriptBox["rx4", "2"]}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
              SuperscriptBox["rx4", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["rx2", "2"], " ", 
              SuperscriptBox["rx4", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ",
               "ry1"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx3", 
              " ", "ry1"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ",
               "ry1"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx3", 
              " ", "ry1"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", 
              SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", 
              SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ",
               "ry1"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx4", 
              " ", "ry1"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ",
               "ry1"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx4", 
              " ", "ry1"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx3", " ", "rx4", " ",
               "ry1"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "rx3", " ", "rx4", 
              " ", "ry1"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", 
              SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", 
              SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["rx3", "2"], " ", 
              SuperscriptBox["ry1", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "rx3", " ", "rx4", " ", 
              SuperscriptBox["ry1", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["rx4", "2"], " ", 
              SuperscriptBox["ry1", "2"]}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", 
              SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", 
              SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx2", " ",
               "ry3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx2", 
              " ", "ry3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", 
              SuperscriptBox["rx2", "2"], " ", "ry3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly3", " ", 
              SuperscriptBox["rx2", "2"], " ", "ry3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ",
               "ry3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx3", 
              " ", "ry3"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ",
               "ry3"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx3", 
              " ", "ry3"}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ",
               "ry3"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx4", 
              " ", "ry3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ",
               "ry3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx4", 
              " ", "ry3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "rx1", " ", "rx3", " ", "ry1", 
              " ", "ry3"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "rx2", " ", "rx3", " ", "ry1", 
              " ", "ry3"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "rx1", " ", "rx4", " ", "ry1", 
              " ", "ry3"}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "rx2", " ", "rx4", " ", "ry1", 
              " ", "ry3"}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["rx1", "2"], " ", 
              SuperscriptBox["ry3", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", "rx1", " ", "rx2", " ", 
              SuperscriptBox["ry3", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["rx2", "2"], " ", 
              SuperscriptBox["ry3", "2"]}]}], ")"}]}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"a", " ", 
           SqrtBox[
            RowBox[{
             RowBox[{"4", " ", 
              SuperscriptBox["rx1", "2"]}], "-", 
             RowBox[{"8", " ", "rx1", " ", "rx2"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["rx2", "2"]}], "+", 
             RowBox[{"8", " ", "rx1", " ", "rx3"}], "-", 
             RowBox[{"8", " ", "rx2", " ", "rx3"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["rx3", "2"]}], "-", 
             RowBox[{"8", " ", "rx1", " ", "rx4"}], "+", 
             RowBox[{"8", " ", "rx2", " ", "rx4"}], "-", 
             RowBox[{"8", " ", "rx3", " ", "rx4"}], "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["rx4", "2"]}]}]]}], ")"}]}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "4"}], " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx2"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx3"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx4"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx4"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx3", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", "rx3", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx3", 
             " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx3", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx4", 
             " ", "ry1"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx3", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx3", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx3", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx3", " ", "rx4", " ", 
             SuperscriptBox["ry1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx4", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx2", " ", 
             "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx2", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx4", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx4", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["ry3", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["ry3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["ry3", "2"]}]}], ")"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"rx3", "-", "rx4"}], ")"}], " ", 
          SqrtBox[
           RowBox[{
            RowBox[{"4", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx2"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"8", " ", "rx1", " ", "rx3"}], "-", 
            RowBox[{"8", " ", "rx2", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx4"}], "+", 
            RowBox[{"8", " ", "rx2", " ", "rx4"}], "-", 
            RowBox[{"8", " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx4", "2"]}]}]]}], ")"}]}]}]}], ",", 
     RowBox[{"ecz", "\[Rule]", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "4"}], " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx2"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx3"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx4"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx4"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx3", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", "rx3", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx3", 
             " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx3", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx4", 
             " ", "ry1"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx3", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx3", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx3", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx3", " ", "rx4", " ", 
             SuperscriptBox["ry1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx4", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx2", " ", 
             "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx2", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx4", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx4", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["ry3", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["ry3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["ry3", "2"]}]}], ")"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"a", " ", 
          SqrtBox[
           RowBox[{
            RowBox[{"4", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx2"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"8", " ", "rx1", " ", "rx3"}], "-", 
            RowBox[{"8", " ", "rx2", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx4"}], "+", 
            RowBox[{"8", " ", "rx2", " ", "rx4"}], "-", 
            RowBox[{"8", " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx4", "2"]}]}]]}], ")"}]}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"z1", "\[Rule]", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "4"}], " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx2"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx3"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx4"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx4"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx3", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", "rx3", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx3", 
             " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx3", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx4", 
             " ", "ry1"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx3", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx3", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx3", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx3", " ", "rx4", " ", 
             SuperscriptBox["ry1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx4", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx2", " ", 
             "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx2", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx4", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx4", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["ry3", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["ry3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["ry3", "2"]}]}], ")"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"a", " ", 
          SqrtBox[
           RowBox[{
            RowBox[{"4", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx2"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"8", " ", "rx1", " ", "rx3"}], "-", 
            RowBox[{"8", " ", "rx2", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx4"}], "+", 
            RowBox[{"8", " ", "rx2", " ", "rx4"}], "-", 
            RowBox[{"8", " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx4", "2"]}]}]]}], ")"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "4"}], " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx2"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx3"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx4"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx4"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx3", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", "rx3", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx3", 
             " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx3", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx4", 
             " ", "ry1"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx3", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx3", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx3", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx3", " ", "rx4", " ", 
             SuperscriptBox["ry1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx4", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx2", " ", 
             "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx2", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx4", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx4", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["ry3", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["ry3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["ry3", "2"]}]}], ")"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"rx1", "-", "rx2"}], ")"}], " ", 
          SqrtBox[
           RowBox[{
            RowBox[{"4", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx2"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"8", " ", "rx1", " ", "rx3"}], "-", 
            RowBox[{"8", " ", "rx2", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx4"}], "+", 
            RowBox[{"8", " ", "rx2", " ", "rx4"}], "-", 
            RowBox[{"8", " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx4", "2"]}]}]]}], ")"}]}]}]}], ",", 
     RowBox[{"y1", "\[Rule]", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "a", " ", "k"}], "-", 
        RowBox[{"a", " ", "ly1"}], "+", 
        RowBox[{"2", " ", "k", " ", "rx1"}], "-", 
        RowBox[{"2", " ", "k", " ", "rx2"}], "-", 
        RowBox[{"a", " ", "ry1"}]}], 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"rx1", "-", "rx2"}], ")"}]}]]}], ",", 
     RowBox[{"y3", "\[Rule]", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", "a", " ", "k"}], "+", 
        RowBox[{"a", " ", "ly3"}], "+", 
        RowBox[{"2", " ", "k", " ", "rx3"}], "-", 
        RowBox[{"2", " ", "k", " ", "rx4"}], "+", 
        RowBox[{"a", " ", "ry3"}]}], 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"rx3", "-", "rx4"}], ")"}]}]]}], ",", 
     RowBox[{"z3", "\[Rule]", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "4"}], " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx2"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx3"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx4"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx4"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx3", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", "rx3", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx3", 
             " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx3", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx4", 
             " ", "ry1"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx3", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx3", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx3", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx3", " ", "rx4", " ", 
             SuperscriptBox["ry1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx4", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx2", " ", 
             "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx2", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx4", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx4", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["ry3", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["ry3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["ry3", "2"]}]}], ")"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"a", " ", 
          SqrtBox[
           RowBox[{
            RowBox[{"4", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx2"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"8", " ", "rx1", " ", "rx3"}], "-", 
            RowBox[{"8", " ", "rx2", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx4"}], "+", 
            RowBox[{"8", " ", "rx2", " ", "rx4"}], "-", 
            RowBox[{"8", " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx4", "2"]}]}]]}], ")"}]}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "4"}], " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx1", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx2"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", "rx1", " ", "rx2"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly3", "2"], " ", 
             SuperscriptBox["rx2", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx3"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx3", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx1", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
             "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx2", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
             "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
             "rx4"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", 
             " ", "rx4"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx3", " ", 
             "rx4"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", "rx3", 
             " ", "rx4"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", "rx3", " ", "rx4"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["k", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["ly1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["b", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["rx4", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx3", 
             " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx3", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx4", 
             " ", "ry1"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx3", " ", "rx4", " ", 
             "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx3", " ", "rx4", 
             " ", "ry1"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", 
             SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx3", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx3", " ", "rx4", " ", 
             SuperscriptBox["ry1", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx4", "2"], " ", 
             SuperscriptBox["ry1", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx2", " ", 
             "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx2", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly3", " ", 
             SuperscriptBox["rx2", "2"], " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx3", 
             " ", "ry3"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
             "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx4", 
             " ", "ry3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
             "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx4", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx3", " ", "ry1", 
             " ", "ry3"}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx2", " ", "rx4", " ", "ry1", 
             " ", "ry3"}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx1", "2"], " ", 
             SuperscriptBox["ry3", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["a", "2"], " ", "rx1", " ", "rx2", " ", 
             SuperscriptBox["ry3", "2"]}], "-", 
            RowBox[{
             SuperscriptBox["a", "2"], " ", 
             SuperscriptBox["rx2", "2"], " ", 
             SuperscriptBox["ry3", "2"]}]}], ")"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"rx3", "-", "rx4"}], ")"}], " ", 
          SqrtBox[
           RowBox[{
            RowBox[{"4", " ", 
             SuperscriptBox["rx1", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx2"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx2", "2"]}], "+", 
            RowBox[{"8", " ", "rx1", " ", "rx3"}], "-", 
            RowBox[{"8", " ", "rx2", " ", "rx3"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx3", "2"]}], "-", 
            RowBox[{"8", " ", "rx1", " ", "rx4"}], "+", 
            RowBox[{"8", " ", "rx2", " ", "rx4"}], "-", 
            RowBox[{"8", " ", "rx3", " ", "rx4"}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["rx4", "2"]}]}]]}], ")"}]}]}]}], ",", 
     RowBox[{"ecz", "\[Rule]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "4"}], " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["k", "2"], " ", 
            SuperscriptBox["rx1", "2"]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
            SuperscriptBox["rx1", "2"]}], "-", 
           RowBox[{
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["ly3", "2"], " ", 
            SuperscriptBox["rx1", "2"]}], "+", 
           RowBox[{"8", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["k", "2"], " ", "rx1", " ", "rx2"}], "-", 
           RowBox[{"8", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
            "rx2"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["ly3", "2"], " ", "rx1", " ", "rx2"}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["k", "2"], " ", 
            SuperscriptBox["rx2", "2"]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", 
            SuperscriptBox["rx2", "2"]}], "-", 
           RowBox[{
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["ly3", "2"], " ", 
            SuperscriptBox["rx2", "2"]}], "-", 
           RowBox[{"8", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["k", "2"], " ", "rx1", " ", "rx3"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
            "rx3"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
            "rx3"}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", " ",
             "rx3"}], "+", 
           RowBox[{"8", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["k", "2"], " ", "rx2", " ", "rx3"}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
            "rx3"}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
            "rx3"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", " ",
             "rx3"}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["k", "2"], " ", 
            SuperscriptBox["rx3", "2"]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
            SuperscriptBox["rx3", "2"]}], "-", 
           RowBox[{
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["ly1", "2"], " ", 
            SuperscriptBox["rx3", "2"]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["rx1", "2"], " ", 
            SuperscriptBox["rx3", "2"]}], "-", 
           RowBox[{"8", " ", 
            SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
            SuperscriptBox["rx3", "2"]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["rx2", "2"], " ", 
            SuperscriptBox["rx3", "2"]}], "+", 
           RowBox[{"8", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["k", "2"], " ", "rx1", " ", "rx4"}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx1", " ", 
            "rx4"}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx1", " ", 
            "rx4"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx1", " ",
             "rx4"}], "-", 
           RowBox[{"8", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["k", "2"], " ", "rx2", " ", "rx4"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx2", " ", 
            "rx4"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly3", " ", "rx2", " ", 
            "rx4"}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly1", " ", "ly3", " ", "rx2", " ",
             "rx4"}], "+", 
           RowBox[{"8", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["k", "2"], " ", "rx3", " ", "rx4"}], "-", 
           RowBox[{"8", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", "rx3", " ", 
            "rx4"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["ly1", "2"], " ", "rx3", " ", "rx4"}], "-", 
           RowBox[{"8", " ", 
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["rx1", "2"], " ", "rx3", " ", "rx4"}], "+", 
           RowBox[{"16", " ", 
            SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", "rx3", " ",
             "rx4"}], "-", 
           RowBox[{"8", " ", 
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["rx2", "2"], " ", "rx3", " ", "rx4"}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["k", "2"], " ", 
            SuperscriptBox["rx4", "2"]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "ly1", " ", 
            SuperscriptBox["rx4", "2"]}], "-", 
           RowBox[{
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["ly1", "2"], " ", 
            SuperscriptBox["rx4", "2"]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["rx1", "2"], " ", 
            SuperscriptBox["rx4", "2"]}], "-", 
           RowBox[{"8", " ", 
            SuperscriptBox["b", "2"], " ", "rx1", " ", "rx2", " ", 
            SuperscriptBox["rx4", "2"]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["rx2", "2"], " ", 
            SuperscriptBox["rx4", "2"]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
            "ry1"}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx3", " ",
             "ry1"}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
            "ry1"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx3", " ",
             "ry1"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", 
            SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly1", " ", 
            SuperscriptBox["rx3", "2"], " ", "ry1"}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
            "ry1"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx4", " ",
             "ry1"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
            "ry1"}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly3", " ", "rx2", " ", "rx4", " ",
             "ry1"}], "-", 
           RowBox[{"8", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "rx3", " ", "rx4", " ", 
            "ry1"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "ly1", " ", "rx3", " ", "rx4", " ",
             "ry1"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", 
            SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly1", " ", 
            SuperscriptBox["rx4", "2"], " ", "ry1"}], "-", 
           RowBox[{
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["rx3", "2"], " ", 
            SuperscriptBox["ry1", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "rx3", " ", "rx4", " ", 
            SuperscriptBox["ry1", "2"]}], "-", 
           RowBox[{
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["rx4", "2"], " ", 
            SuperscriptBox["ry1", "2"]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", 
            SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly3", " ", 
            SuperscriptBox["rx1", "2"], " ", "ry3"}], "-", 
           RowBox[{"8", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx2", " ", 
            "ry3"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "ly3", " ", "rx1", " ", "rx2", " ",
             "ry3"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", 
            SuperscriptBox["rx2", "2"], " ", "ry3"}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly3", " ", 
            SuperscriptBox["rx2", "2"], " ", "ry3"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx3", " ", 
            "ry3"}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx3", " ",
             "ry3"}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx3", " ", 
            "ry3"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx3", " ",
             "ry3"}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "rx1", " ", "rx4", " ", 
            "ry3"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly1", " ", "rx1", " ", "rx4", " ",
             "ry3"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["a", "2"], " ", "k", " ", "rx2", " ", "rx4", " ", 
            "ry3"}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "ly1", " ", "rx2", " ", "rx4", " ",
             "ry3"}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "rx1", " ", "rx3", " ", "ry1", " ",
             "ry3"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "rx2", " ", "rx3", " ", "ry1", " ",
             "ry3"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "rx1", " ", "rx4", " ", "ry1", " ",
             "ry3"}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "rx2", " ", "rx4", " ", "ry1", " ",
             "ry3"}], "-", 
           RowBox[{
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["rx1", "2"], " ", 
            SuperscriptBox["ry3", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", "rx1", " ", "rx2", " ", 
            SuperscriptBox["ry3", "2"]}], "-", 
           RowBox[{
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["rx2", "2"], " ", 
            SuperscriptBox["ry3", "2"]}]}], ")"}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"a", " ", 
         SqrtBox[
          RowBox[{
           RowBox[{"4", " ", 
            SuperscriptBox["rx1", "2"]}], "-", 
           RowBox[{"8", " ", "rx1", " ", "rx2"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["rx2", "2"]}], "+", 
           RowBox[{"8", " ", "rx1", " ", "rx3"}], "-", 
           RowBox[{"8", " ", "rx2", " ", "rx3"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["rx3", "2"]}], "-", 
           RowBox[{"8", " ", "rx1", " ", "rx4"}], "+", 
           RowBox[{"8", " ", "rx2", " ", "rx4"}], "-", 
           RowBox[{"8", " ", "rx3", " ", "rx4"}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["rx4", "2"]}]}]]}], ")"}]}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.4936996575328*^9, 3.49369970981993*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ecz", "/.", "secz"}], "//", "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.493699757316343*^9, 3.493699777656519*^9}}],

Cell["\<\
{-(Sqrt[4*b^2*(rx1 - rx2)^2*(rx3 - rx4)^2 - a^2*(2*k*(-rx1 + rx2 - rx3 + rx4) \
+ (rx3 - rx4)*(ly1 + ry1) + 
         (rx1 - rx2)*(ly3 + ry3))^2]/(2*a*Sqrt[(rx1 - rx2 + rx3 - rx4)^2])), 
  Sqrt[4*b^2*(rx1 - rx2)^2*(rx3 - rx4)^2 - a^2*(2*k*(-rx1 + rx2 - rx3 + rx4) \
+ (rx3 - rx4)*(ly1 + ry1) + 
        (rx1 - rx2)*(ly3 + ry3))^2]/(2*a*Sqrt[(rx1 - rx2 + rx3 - rx4)^2])}\
\>", "Input",
 CellChangeTimes->{{3.493699859428608*^9, 3.493699873702644*^9}}]
},
WindowSize->{1022, 540},
WindowMargins->{{0, Automatic}, {6, Automatic}},
ShowSelection->True,
FrontEndVersion->"7.0 for Linux x86 (32-bit) (February 25, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 9458, 241, 781, "Input"],
Cell[10028, 265, 3159, 92, 130, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13224, 362, 202, 4, 32, "Input"],
Cell[13429, 368, 300, 9, 47, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13766, 382, 153, 3, 32, "Input"],
Cell[13922, 387, 512, 18, 51, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14471, 410, 152, 3, 32, "Input"],
Cell[14626, 415, 219, 6, 45, "Output"]
}, Open  ]],
Cell[14860, 424, 151, 3, 32, "Input"],
Cell[15014, 429, 444, 14, 32, "Input"],
Cell[CellGroupData[{
Cell[15483, 447, 1251, 35, 77, "Input"],
Cell[16737, 484, 3221, 95, 130, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19995, 584, 193, 5, 55, "Input"],
Cell[20191, 591, 270, 9, 47, "Output"]
}, Open  ]],
Cell[20476, 603, 92, 1, 32, "Input"],
Cell[20571, 606, 92, 1, 32, "Input"],
Cell[CellGroupData[{
Cell[20688, 611, 153, 3, 32, "Input"],
Cell[20844, 616, 473, 15, 51, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21354, 636, 153, 3, 32, "Input"],
Cell[21510, 641, 238, 7, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21785, 653, 152, 3, 32, "Input"],
Cell[21940, 658, 421, 14, 31, "Output"]
}, Open  ]],
Cell[22376, 675, 141, 2, 32, "Input"],
Cell[22520, 679, 141, 2, 32, "Input"],
Cell[CellGroupData[{
Cell[22686, 685, 680, 21, 55, "Input"],
Cell[23369, 708, 614, 20, 62, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24020, 733, 156, 3, 32, "Input"],
Cell[24179, 738, 105, 1, 31, "Output"]
}, Open  ]],
Cell[24299, 742, 91, 1, 32, "Input"],
Cell[24393, 745, 552, 16, 32, "Input"],
Cell[CellGroupData[{
Cell[24970, 765, 2084, 65, 100, "Input"],
Cell[27057, 832, 131272, 2905, 3900, "Output"]
}, Open  ]],
Cell[158344, 3740, 156, 3, 32, "Input"],
Cell[158503, 3745, 460, 8, 86, "Input"]
}
]
*)

(* End of internal cache information *)
